//project Billy is a project by Josien Vos (HKU, January 2017)
//this game only works if an arduino is plugged into the computer and the standardfirmata is installed on it.
//please don't complain too much about the bugs and glitches? I'm not really a programmer and only had two weeks to build all the code and the doll

//import external libraries to processing
import processing.serial.*;
import cc.arduino.*;
import ddf.minim.*;
import ddf.minim.analysis.*; //i'm unsure whether this line is required

Arduino arduino;
Minim minim;
AudioPlayer gunSound;

PFont western;
boolean trigger, gameOver;
float armAngle, shotsFired, time, textX, textY, pi, x, y, highscore;

Billy player = new Billy(250,450,40,0); //these variables represent xPosition, yPosition, size and the angle of his arm at the start of the game.
Score score = new Score();

ArrayList<Bullet> bullets = new ArrayList<Bullet>();
ArrayList<Target> targets = new ArrayList<Target>();

void setup() {
  size(1980, 1000);
  
//start the used libraries
  println(Arduino.list());
  arduino = new Arduino(this, Arduino.list()[0], 57600);
  minim = new Minim(this);
  
  gunSound = minim.loadFile("boem.mp3", 2048); //change the name of this file and add another sound file to data to have another sound
  western = createFont("BouWesternFont.ttf",30); //imports the downloaded font to processing
  textFont(western);
  textAlign(CENTER);
  textSize(30);
  
//declare the used pins of the arduino
  arduino.pinMode(2, Arduino.INPUT_PULLUP);
  arduino.pinMode(4, Arduino.OUTPUT);
  arduino.pinMode(6, Arduino.OUTPUT);
  arduino.digitalWrite(4, Arduino.LOW);
  arduino.analogWrite(6, 0);
  
  shotsFired = -1;
  time = 0;
  textX = width/2;
  textY = 120;
  gameOver = false;
  highscore = 0;
  pi = 3.14159265359; //should be accurate enough. it's not like i'm doing science here. just need to shoot 'em targets, eh?
}

void draw() {
  background(200,200,250);
  
  //now i make a simple background using trigonometry (goniometrie, sin & cos)
  //i can't make it very smooth, because that would take more calculations and make the game slower
  strokeWeight(80);
  stroke(250,230,200);
  fill(250,230,200);
  rect(0,height/2,width,height/2);
  for (int i = 0; i < 55; i++) {
    x = width/50*i+1;
    y = height/2 - 30 + cos(i/2.5)*10;
    point(x,y);
  }
  stroke(250,220,160);
  fill(250,220,160);
  rect(0,height/2+110,width,height/2);
  for (int i = 0; i < 55; i++) {
    x = width/50*i+1;
    y = height/2 + 80 + cos(i/3.0)*13;
    point(x,y);
  }
  stroke(250,200,120);
  fill(250,200,120);
  rect(0,height-200,width,height/2);
  for (int i = 0; i < 55; i++) {
    x = width/50*i+1;
    y = height - 230 + cos(i/8.0)*18;
    point(x,y);
  }
  
  fill(0);
  textAlign(CENTER);
  
  
  
  armAngle = arduino.analogRead(5) /1.2 + 100; //change this formula if your arm is moving wrong.
  
  //shooting code
  player.update(armAngle); //aim the arm before shooting
  // if the key is pressed, the red light turns on, a sound is played, and a bullet is shot
  if (arduino.digitalRead(2) == Arduino.LOW && time > -20) {
    arduino.digitalWrite(4, Arduino.HIGH);
    if (trigger==false) {
      if (gunSound.isPlaying() ) {
        arduino.digitalWrite(4, Arduino.LOW);
        gameOver = false;
      }
      else {
        gunSound.rewind();
        gunSound.play(); //BANG BANG
        arduino.digitalWrite(4, Arduino.HIGH); //flash of light in the gun
        bullets.add(new Bullet(player.gunX,player.gunY,player.howBig,20,armAngle)); //create a bullet at the gun, in the direction of the arm
        trigger = true;
        shotsFired += 1;
      }
    }
    if (gunSound.isPlaying() == false) {
      arduino.digitalWrite(4, Arduino.LOW); //turn the light off when the sound is gone
    }
  }
  else if (trigger) {
    trigger = false;
    arduino.digitalWrite(4, Arduino.LOW);
  }
  
  
  
  //check whether a target is hitting the player. if so, game over.
  for (int i = 0; i < targets.size(); i++) {
    Target tar = targets.get(i);
    if (dist(player.xPos, player.yPos, tar.xPos, tar.yPos) < player.howBig) {
      gameOver = true;
      time = -255;
      trigger = false;
      if (score.score > highscore) {
        highscore = int(score.score);
      }
      score.reset();
      shotsFired = 0;
      for (int j = 0; j < targets.size(); j++) {
        //Target tar = targets.get(j);
        targets.remove(0); // tries to remove all of the targets
      }
      for (int j = 0; j < targets.size(); j++) {
        targets.remove(0); // tries to remove all of the targets (added this because it didn't always work with all of them when there were many)
      }
    }
  }
  
  
  
  //text and targets are regulated in the code below
  if (time <= 0) {
    text("Pull the trigger to get shootin'.", textX, textY);
  }
  else {
    if (score.score == 0 && targets.size() == 0) {
      for (int i = 1; i < 6; i++) {
        targets.add(new Target(width-player.howBig*4, height/5*i-height/10, player.howBig*3, 1)); //add the first targets
      }
    }
    else if (score.score < 5) {
      text("Move yer arm to aim at 'em targets, pull the trigger to put a bullet in 'em.", textX, textY);
    }
    
    if (score.score > 4 && score.score < 6) {
      text("Shoot 'em movin' targets before they reach you.", textX, textY);
      if (targets.size() < 1) {
        targets.add(new Target(width-player.howBig*4, height/2, player.howBig*3, 5)); //the first moving target, the slowest you'll ever get
      }
    }
    
    if ((score.score > 9 && time%int(200-score.score/10) == 0) || (targets.size() == 0)) {
      for (int i = 0; i < int(random(0,3+score.score/20)); i++) {
        targets.add(new Target(width+player.howBig*1.5, height*random(0.1,0.9), 3*player.howBig, random(5+score.score/10,6+score.score))); //random moving targets, until the end
      }
    }
    
    
    
    //targets are updated here.
    for (int i = 0; i < targets.size(); i++) {
      Target tar = targets.get(i);
      tar.update();
    }
    
    //bullets are updated and collisions are checked.
    boolean hit;
    int amount = targets.size();
    hit = false;
    for (int i = 0; i < bullets.size(); i++) {
      Bullet bull = bullets.get(i);
      bull.update();
      for (int j = 0; j < targets.size(); j++) {
        Target tar = targets.get(j);
        if (abs(bull.xPos-tar.xPos) < tar.howBig/2 && abs(bull.yPos-tar.yPos) < tar.howBig/2) { //check whether a target was hit
          targets.remove(j);
          score.up(tar.lvl);
          hit = true;
        }
        else {
          tar.display();
        }
      }
      if (hit == true) {
        bullets.remove(i); //deletes bullets that hit a target
      }
      else if (bull.xPos > width || bull.yPos < 10 && time < 10 || bull.yPos > height) {
        bullets.remove(i); //deletes bullets that have gone off-screen
      }
      else if (targets.size() == 0 || hit == false) {
        bull.display(); //displays existent bullets
      }
      
    }
    
    //targets are displayed
    for (int j = 0; j < targets.size(); j++) {
      Target tar = targets.get(j);
      tar.display();
    } //this is the end of the target and bullet checking :O
  }
  
  
  player.display(); //show Billy in all his glory
  textAlign(LEFT);
  score.display();
  textAlign(RIGHT);
  text("Highscore: " + int(highscore), width-100, height-40);
  
  //de lichtgevende ogen
  if (time < 150 && time > 0) {
    arduino.analogWrite(6, int(time/7.5));
  }
  else if (time >= 150) {
    arduino.digitalWrite(6, Arduino.HIGH);
  }
  else {
    arduino.analogWrite(6, 0);
  }
  
  //verhoog de tijd met 1
  time += 1;
}
//
//this appears to be important. i have no idea what it really does. stops all the sounds from playing on?
void stop() {
  // always close Minim audio classes when you are finished with them
  gunSound.close();
  // always stop Minim before exiting
  minim.stop();
  // this closes the sketch
  super.stop();
}